﻿
// ---------------------- top of file ContrPnl.cs ----------------------
using System;
using System.Windows.Forms;
using System.Drawing; 
public class ControlPanel : Panel { 
    public ComboBox comboNA = new ComboBox(), comboNT = new ComboBox();  
	public Button[] buttoneffectsz=new Button[6]; 
    MyForm par; 
    public ControlPanel (MyForm partf) { 
        par = partf; 
        BackColor = Color.SkyBlue; // 
        // 
        Label L1 = new Label(), L2 = new Label(); 
        Controls.Add(L1); L1.Width = 38; 
        Controls.Add(L2); L2.Width = 38;
        L1.Text = "行内字数"; L2.Text = "頁内行数"; 
        comboNA.MaxDropDownItems = 28; 
        comboNT.MaxDropDownItems = 42;
        int iwpv = -112; 
        L1.SetBounds(iwpv + 122, 3, 32, 30); 
        comboNA.SetBounds(iwpv + 122+36, 5, 32, 20); 
        L2.SetBounds(iwpv + 207, 3, 32, 30); 　
        comboNT.SetBounds(iwpv + 207+36, 5, 32, 20); 
        Controls.Add(L1);　
        Controls.Add(L2); 
        Controls.Add(comboNA); comboNA.Width = 40; 
        Controls.Add(comboNT); comboNT.Width = 40;  
        par.setNANT(26, 20); 
        prepcombohorizontalz();  
        comboNT.SelectedIndexChanged += (o, e) => { 
            try { par.setNANT(par.getNA(), int.Parse(comboNT.SelectedItem.ToString())); 
            } catch { setasnumb(comboNT, par.getNT()); } 
            int NAlim = 26; 
            if (par.getNT() > 26) {
                NAlim = 13;  
            } else if (par.getNT() > 20) {
                NAlim = 20; } 
            if (par.getNA() > NAlim) {
                setasnumb(comboNA, NAlim);  }  
            par.textpanel.rich.Select();  
            par.textpanel.resize(); 
            setasnumb(comboNA, par.getNA());
            string nan = comboNA.Text;  
            par.setNANT(int.Parse(comboNA.Text), int.Parse(comboNT.Text)); 
            par.panele.onsizechanged(); 
            par.panele.Invalidate();  
            par.edited = true; 
        }; 
        comboNA.SelectedIndexChanged += (o, e) => {
            try { par.setNANT(int.Parse(comboNA.SelectedItem.ToString()),par.getNT());
            } catch { setasnumb(comboNA, par.getNA()); }  
            int NTlim = 40; 
            if (par.getNA() > 20) {
                NTlim = 20; 
            } else if (par.getNA() > 13) {
                NTlim = 26;  } 
            if (par.getNT() > NTlim) {
                setasnumb(comboNT, NTlim);  }  
            par.textpanel.rich.Select();  
            par.textpanel.resize(); 
            par.setNANT(int.Parse(comboNA.Text), int.Parse(comboNT.Text)); 
            par.panele.onsizechanged(); 
            par.panele.Invalidate(); 
            par.edited = true; 
        };

        string[] btexts = new string[] {" ","﹅","﹆","•","◦","―" }; 
        int[] ieffects = new int[] {0,2,4,6,8,1}; 
        for (int i=0; i<6; i++) {
            buttoneffectsz[i] = new Button(); 
                buttoneffectsz[i].SetBounds(240 + i * 30, 4, 25, 22); 
            buttoneffectsz[i].Text = btexts[i];
            buttoneffectsz[i].Font=new Font("MS UI Gothic", 14); 
                buttoneffectsz[i].Visible = false;
                buttoneffectsz[i].Click += (o,e)=>{
                    par.edited = true; 
                    for (int j=0; j<6; j++) { 
                        if (o == buttoneffectsz[j]) {
                            par.textbank.regionallysetmodi(ieffects[j]); 
                            par.textbank.setcursori(par.textbank._iR); 
                            par.textpanel.overpanel.Refresh();
                            hideeffectbuttons();
                            par.textpanel.rich.Select(); 
                            return; 
                        } 
                    }  
                };  
            Controls.Add(buttoneffectsz[i]); 
        } 
        Label L6 = new Label(); 
        L6.Text = "zoom"; 
        L6.SetBounds(360, 3, 30, 30); 
    } // ========================================================  
    public void showeffectbuttons() { 
        for (int i=0; i<6; i++) {
            buttoneffectsz[i].Visible = true; 
        } 
    } // ========================================================  
    public void hideeffectbuttons() { 
        for (int i=0; i<6; i++) {
            buttoneffectsz[i].Visible = false; 
        } 
    } // ========================================================  

    public int combochangeticket=0; 
    public void prepcombohorizontalz() {
        comboNT.Items.Clear();
        comboNA.Items.Clear();
        for (int i=40; i>=2; i--) { // 40 8
            if (i == 26 || i == 20) { 
                comboNT.Items.Add(""); }  
            comboNT.Items.Add(i.ToString()); }  
        for (int i=26; i>=2; i--) { // 26 10
            if (i == 20 || i == 13) { 
                comboNA.Items.Add(""); }  
            comboNA.Items.Add(i.ToString()); }
        setasnumb(comboNT, par.getNT()); 
        setasnumb(comboNA, par.getNA());  
        if (par.textpanel != null) {  
            if (par.menu_Mode_Design.Checked) {
                return; } 
            par.textpanel.vscrz.setbase(0); } 
            
        par.setNANT(int.Parse(comboNA.Text), int.Parse(comboNT.Text)); 
    } // ======================================================== 
    public void prepcombovertical() {
        comboNT.Items.Clear();
        comboNA.Items.Clear(); 
        for (int i=26; i>=2; i--) { // 40 8 
            comboNT.Items.Add(i.ToString()); }  
        for (int i=20; i>=2; i--) { // 26 10 
            comboNA.Items.Add(i.ToString()); }
        if (par.getNT() > 26 || par.getNA() > 20) { 
            par.setNANT(20, 26); } 
        setasnumb(comboNT, par.getNT()); 
        setasnumb(comboNA, par.getNA()); 
        if (par.menu_Mode_Design.Checked) {
            return; } 
        par.textpanel.hscr.setbase(0); 

        par.setNANT(int.Parse(comboNA.Text), int.Parse(comboNT.Text)); 
    } // ========================================================  
    void setasnumb(ComboBox combo, int ntf) {
        for (int i=0; i<combo.Items.Count; i++) { //  string str in combo.Items) { 
            string str = combo.Items[i].ToString(); 
            int n = 0; 
            try{ n = int.Parse(str); } catch { }
            if (n == ntf) { 
                combo.SelectedIndex = i; } } 
    } // ========================================================  
} // ############################################################ 
public class ControlPanel2 : Panel { 
    public ComboBox comboSF = new ComboBox(), comboSA = new ComboBox(), comboST= new ComboBox(), 
        comboP=new ComboBox(); 
    MyForm par; 
    public ControlPanel2(MyForm partf) {
        par = partf;
        BackColor = Color.Coral; //         par.BackColor; //         Color.Azure; 
        decimal hbyw=0.65m; 
        Label L3 = new Label(); 
        L3.SetBounds(10, 3, 39, 30);
        L3.Text = "フォント(Point)"; 
        comboSF.SetBounds(50, 5,38,20);
        for (int i=6; i<=24; i++) { comboSF.Items.Add((i*1.0).ToString()); } 
        comboSF.MaxDropDownItems = 38;
        comboSA.Items.Add("0"); comboSA.SelectedIndex = 0; 
        comboST.Items.Add("0"); comboST.SelectedIndex = 0; 
        comboSF.SelectedIndexChanged += (o, e) => {
            decimal df = decimal.Parse((string)comboSF.SelectedItem);
            if (par.textpanel != null) { 
                par.textpanel.setfsize((string)comboSF.SelectedItem); }  
            string str1 = comboSA.SelectedItem.ToString(); 
            bool matched = false; 
            comboSA.Items.Clear(); 
            int i0=(int)(1+0.33m*df*2);
            for(int i = i0; i <= 24; i++) {
                string strhere = (i * 0.5).ToString(); 
                comboSA.Items.Add(strhere); 
                if (strhere == str1) { matched = true; } }
            if (matched) {
                comboSA.SelectedItem = str1; 
            } else {  
                comboSA.SelectedIndex = 1; } // 1
            //  
            string str2 = comboST.SelectedItem.ToString();
            matched = false; 
            comboST.Items.Clear();  
            decimal dc = decimal.Parse((string)comboSA.SelectedItem);
            int j0=(int)(1+hbyw*df*2), j1=(int)Math.Ceiling(2.4m*dc); 
            for(int i = j0; i <= 48; i++) {
                string strhere=(i * 0.5).ToString(); 
                comboST.Items.Add(strhere); 
                if (strhere == str2) { matched = true; } } 
            if (matched) { comboST.SelectedItem = str2; 
            } else { 
                comboST.SelectedIndex = 5; } // 5 
            if (par.textpanel == null) { return; }
            par.textpanel.rich.Select(); 
            
            par.textpanel.setfontdesign(); // used only designing !!! 　

            par.panele.onsizechanged(); 
            par.panele.Invalidate(); 
            par.edited = true; 
        };
        Controls.Add(L3); 
        Controls.Add(comboSF); 
        Label L4 = new Label(); 
        L4.Text = "歩幅(mm)";
        comboSF.SelectedIndex = 8; // 14p 
        string strr = comboSF.SelectedItem.ToString(); 
        comboSA.SelectedIndexChanged += (o, e) => { // === enabled only page editor case !!! 
            decimal dc = decimal.Parse(comboSA.SelectedItem.ToString()); 
            string str = comboST.SelectedItem.ToString();
            bool matched = false; 
            comboST.Items.Clear(); 
            decimal df = decimal.Parse((string)comboSF.SelectedItem);
            int j0=(int)(1+hbyw*df*1.1m), j1=(int)Math.Ceiling(1.4m*dc); 
            if (j0<j1) { j0 = j1; } 
            for(int i = j0; i <= 48; i++) {
                string strhere = (i * 0.5).ToString(); 
                comboST.Items.Add(strhere); 
                if (strhere == str) { matched = true; } } 
            if (matched) { comboST.SelectedItem=str; 
            } else { comboST.SelectedIndex = 0; } 
            if (par.textpanel == null) { return; }   
            par.textpanel.rich.Select();   
            par.textpanel.setfontdesign(); // used only designing !!! 
            par.setSAST(decimal.Parse(comboSA.Text), decimal.Parse(comboST.Text)); 
            par.panele.onsizechanged(); 
            par.panele.Invalidate(); 
            par.edited = true; 
        }; 
        comboSA.SelectedIndex = 2;
        comboST.SelectedIndexChanged += (o, e) => { // === enabled only page editor case !!! 
            if (par.textpanel == null) { return; } 
            par.textpanel.setfontdesign(); // used only designing !!! 
		    par.textpanel.resize(); 
            par.textpanel.rich.Select();    
            par.setSAST(decimal.Parse(comboSA.Text), decimal.Parse(comboST.Text));  
            par.panele.onsizechanged(); 
            par.panele.Invalidate(); 
            par.edited = true; 
        }; 
        comboST.SelectedIndex = 5; 
        par.setSAST(decimal.Parse(comboSA.SelectedItem.ToString()), decimal.Parse(comboST.SelectedItem.ToString()));  
        Label L5 = new Label(); 
        L4.SetBounds(110, 3, 39, 30); 
        comboSA.SetBounds(150, 5,44,20); 
        L5.SetBounds(210, 3, 39, 30);
        comboST.SetBounds(250, 5,44,20); 
        L5.Text = "行幅(mm)"; 
        comboSA.MaxDropDownItems = 88;
        comboST.MaxDropDownItems = 44;
        Controls.Add(L4); Controls.Add(L5);
        Controls.Add(comboSA); 
        Controls.Add(comboST); 
        Label L6 = new Label(); 
        L6.Text = "ページ"; 
        L6.SetBounds(310, 3, 39, 30);
        comboP.SetBounds(350, 5,44,20);
        comboP.MaxDropDownItems = 100; 
        for (int i=1; i<=30; i++) {
            comboP.Items.Add(i.ToString()); }
        comboP.SelectedIndexChanged += (o, e) => {
            if (par.textpanel == null) { return; }  
            par.textpanel.setfontdesign(); // used only designing !!!  
            par.textpanel.rich.Select(); 
            par.panele.Invalidate(); 
        }; 
        comboP.SelectedIndex = 0; 
        Controls.Add(L6); Controls.Add(comboP); 
    } // =================================================================== 
} // ####################################################################### 
// ---------------------- bottom of file ContrPnl.cs ----------------------

