﻿
// ---------------------- top of file TextBank.cs ----------------------
using System.Collections.Generic; 
using System.Windows.Forms;
public class TextBank {
    public List<TextPlace> placeLs=new List<TextPlace>();
    public List<int> wofi = new List<int>(); 
    public List<int> pls = new List<int>();  // page top lines !!! 
    public List<int> modifs = new List<int>(); 
    // ============== concerning ctrl-Z and ctrl-shift-Z =======================  
    public int ptrtextsnowz; 
    public List<string> _textshence=new List<string>();
    public List<int> _cursorhence = new List<int>();   
    public List<List<int>> _modifshence=new List<List<int>>();  
    // ============== concerning ctrl-C, ctrl-X and ctrl-V =====================  
    public List<int> intsclip = new List<int>(); 
    private string privateclipboard="";  
    // ================== concerning ↑ and ↓ ================================= 
    public int ixrealz = 0; 
    public int TBB {get{ return pls[pls.Count - 1] + par.getNT(); } } 
    MyForm par; 
    public TextBank(MyForm partf) { 
        par = partf;  
        _textshence.Add("");
        _cursorhence.Add(0);
        _modifshence.Add(new List<int>());
        pls.Add(0);
        placeLs.Add(new TextPlace(0,0)); 
    } // ========================================================
    public void purgetext(string str)  {  
        text = str;
        modifs.Clear(); 
        for (int i=0; i<_text.Length; i++) { modifs.Add(0); }
        Step2(); 
        setcursori(0); 
    } // ======================================================== 
    public string _text = ""; 
    public string text {
        get{  
            return _text; } 
        set{
            if (par.controlPanel.combochangeticket>0) {
                par.controlPanel.combochangeticket--; 
            } else {    
                par.filenameactive = null; }  
            _text = value; }  
    } // ======================================================== 
    // ###################### cursor handler ###################### 
    public int _idn=0, _iL = 0, _iR = 0, _iLpreset=-1; 
    public bool ctrlvpressed = false, ctrlzypressed = false; 
    public void Step1edit(char ic) {   // 37 <-   39 ->  8 backspace  46 delete  38 up 
        // if (ic == 'v') === clipboard content is first pasted on rich and next 
        //                  copied to textpanel, so cursor is properly increased !!! 
        int icursori = getcursori(); 
        ctrlvpressed = false; // === temporary !!!   
	    if ((Control.ModifierKeys & Keys.Control) == Keys.Control) { 
            if (ic == (char)17 || ic == (char)16) { return; } // ctrl,  shift 
            par.controlPanel.hideeffectbuttons(); 
            switch (ic) {
                case 'V':  // 86:'V'  
                    ctrlvpressed = true; 
                    return; 
                case 'C':  // 67:'C'  
                    if (icursori < 0) { // when region selected 
                        int iLhere = getiL(); 
			            string strtocopy=text.Substring(iLhere, getiR() - iLhere); // "%#"+ 
			            Clipboard.SetText(strtocopy);
                        privateclipboard = strtocopy; 
                        intsclip.Clear(); 
                        intsclip = listcopy(iLhere, _iR, modifs); }
                    return; // === because refresh is not necessary !!! 
                case 'Z':  // 90:'Z' 
                    if ((Control.ModifierKeys & Keys.Shift) == Keys.Shift) { 
                        tofore(); 
                    } else { 
                        tobefore(); }
                    ctrlzypressed = true; 
                    break;
                case 'X': //  88:'X' 
                    if (icursori < 0) { // when region selected 
                        int iLhere = getiL(); 
			            string strtocopy=text.Substring(iLhere, getiR() - iLhere); // "%#"+ 
			            Clipboard.SetText(strtocopy);
                        privateclipboard = strtocopy; 
                        intsclip.Clear(); 
                        intsclip = listcopy(iLhere, _iR, modifs); 
                        regionalremovefull(_iL, _iR); 
                        setcursori(iLhere); }
                    break;
                case '\r': //  13:'\r' // page renew 
                    regionalreplace0("\f");   // yes used when ctrl-enter !!!
                    setcursoripre(_iL + 1);
                    break;
                case 'B':  //  66:'B' underline 
                    if (icursori < 0) { // when region selected 
                        regionallysetmodi(1); 
                        setcursori(_iR); }
                    break; 
                case 'S': //  83:'S' 
                    if (icursori < 0) { // when region selected 
                        regionallysetmodi(2); 
                        setcursori(_iR); }
                    break;
                case 'D': //  68:'D' 
                    if (icursori < 0) { // when region selected 
                        regionallysetmodi(4); 
                        setcursori(_iR); } 
                    break; 
                case 'F': //  70:'F' 
                    if (icursori < 0) { // when region selected 
                        regionallysetmodi(6); 
                        setcursori(_iR); } 
                    break; 
                case 'G': //  71:'G' 
                    if (icursori < 0) { // when region selected 
                        regionallysetmodi(8); 
                        setcursori(_iR); } 
                    break; 
                case 'W': //  87:'W' 
                    if (icursori < 0) { // when region selected 
                        regionallyresetmodi(); 
                        setcursori(_iR); } 
                    break; }
            ixrealz = placeLs[_iL].A; 
            par.textpanel.overpanel.Refresh();  return; } 
        par.controlPanel.hideeffectbuttons(); 
        bool vertif = false; 
        if (par.menu_Mode_Vertical.Checked) {
            vertif = true; } 
        switch (ic) { 
            case ('\r'): // 13: carrige return  
                regionalreplace0("\n");  
                setcursoripre(_iL+1); break;
            case ('\f'): // 12: page renew   
                regionalreplace0("\f");   // presumably not used !!! 
                setcursoripre(_iL + 1); break;  
            case ('.'):  // 46: delete 
                if (icursori < 0) { 
                    regionalremovefull(_iL, _iR); 
                    setcursori(_iL); 
                } else if (icursori < text.Length) { 
                    regionalremovefull(_iL, _iL+1); } 
                break; 
            case ('\b'): // 8: back space 
               if (icursori < 0) { 
                    regionalremovefull(_iL, _iR); 
                    setcursori(_iL); 
                } else if (icursori > 0) { 
                    regionalremovefull(_iL-1, _iL); 
                    setcursori(icursori-1); } 
                break; 
            case ('%'): // 37: left 
                if (vertif) { // tinc 
                    if (icursori < 0) { 
                        setcursori(getiR()); 
                    } else { 
			            inc10cursori(); 
                        par.textpanel.overpanel.Refresh();
                        return; 
                        } 
                } else {
                    adec(icursori); 
                }  
                break;  
            case ('\''): // 39:right 
                if (vertif) { // tdec
                    if (icursori < 0) {
                        setcursori(getiL()); 
                    } else {
			            dec10cursori();
                        par.textpanel.overpanel.Refresh();
                        return; } 
                } else {
                    ainc(icursori); 
                } 
                break; 
            case ('&'): // 38:up            // 33! :pageup   34" :pagedown 
                if (vertif) { // adec  
                    adec(icursori); 
                } else { // tdec
                    if (icursori < 0) {
                        setcursori(getiL()); 
                    } else {
			            dec10cursori();
                        par.textpanel.overpanel.Refresh();
                        return; }
                } 
                break; 
            case ('('): // 40:dn 
                if (vertif) { // ainc 
                    ainc(icursori);  
                } else { // tinc 
                    if (icursori < 0) {
                        setcursori(getiR()); 
                    } else {
			            inc10cursori(); 
                        par.textpanel.overpanel.Refresh();
                        return; 
                        } }  
                break; }
        ixrealz=placeLs[_iL].A; 
		par.textpanel.overpanel.Refresh();  
    } // ========================================================================== 
    public void regionalreplace0(string strtoadd) { // button and ctrl-enter(horiz and verti) trigger 
        text= text.Substring(0, _iL) + strtoadd + text.Substring(_iR);  
        for (int i=_iL; i<_iR; i++) { modifs.RemoveAt(_iL); }  
        int iRtobe = _iL + strtoadd.Length;
        // ============= 傍点 ========================== 
        bool samef = (strtoadd == privateclipboard); 
        if (ctrlvpressed && samef) {
            for (int i=_iL; i<iRtobe; i++) { modifs.Insert(i, intsclip[i-_iL]); }
            ctrlvpressed = false; 
        } else {  
            for (int i=_iL; i<iRtobe; i++) { modifs.Insert(_iL, 0); } } 
    } // ========================================================================== 
    void regionalremovefull(int L, int R) { 
        text = text.Substring(0, L) + text.Substring(R);
        for (int i=L; i<R; i++) { modifs.RemoveAt(L); }  
    } // ==========================================================================  
    public void regionallysetmodi(int f) {
        if (f == 0) {
            for (int i=_iL; i<_iR; i++) { modifs[i] = (modifs[i]/16)*16; } 
        } else if (f == 1) {
            for (int i=_iL; i<_iR; i++) { modifs[i] ^= 1; }  
        } else {
            for (int i=_iL; i<_iR; i++) {
                int iorig = modifs[i], io1=iorig & 1, io8=(iorig/16)*16, io81=(io1|io8)^f; 
                modifs[i] = io81; } } 
    } // ==========================================================================  
    void regionallyresetmodi() {  
        for (int i=_iL; i<_iR; i++) { modifs[i] = 0; }  
    } // ==========================================================================  
    int stati = 0; 
    public void Step2() { // 26,4 
        int NA = par.getNA(), NT = par.getNT();  
        placeLs = new List<TextPlace>();
        wofi = new List<int>();
        pls.Clear(); pls.Add(0);
        int iytot = 0; 
        int ix = 0, iypagetop=0;  
        bool modelinetopf = true; // begin with true 
        for (int i=0 ; i<text.Length; i++) {
            char stri = text[i]; 
            int widthhere = InCertif.numsbycode(ref modelinetopf, stri);
            wofi.Add(widthhere); 
            if (stri == '\n') {  // 13  
                placeLs.Add(new TextPlace(ix, iytot));  
                ix = 0;              iytot++; // ***  
                if (iytot-iypagetop >= NT) {
                    iypagetop += NT; 
                    pls.Add(iytot); } // == iypagetop 
            } else  if (stri == '\f') {  // 12  
                placeLs.Add(new TextPlace(ix, iytot));
                iytot++; 
                iypagetop = iytot; 
                pls.Add(iytot); // increased one 
                ix = 0; 
            } else if (ix == NA && "}」』】］〕₎）｝｠〉›»＞≫｠〗〛]〙⁆,.;、。".IndexOf(stri) >= 0) {  
                ix = 0; iytot++; 
                placeLs[placeLs.Count-1] = new TextPlace(ix, iytot);
                if (iytot-iypagetop >= NT) {
                    iypagetop += NT; 
                    pls.Add(iypagetop);  } 
                placeLs.Add(new TextPlace(1, iytot)); 
                ix = 1+wofi[wofi.Count - 1]; 
            } else if (ix+1 >= NA && "{「【『［〔₍（｛｟〈‹«＜≪〖〚[〘⁅".IndexOf(stri) >= 0) {  
                ix = 0; iytot++; 
                if (iytot-iypagetop >= NT) {
                    iypagetop += NT; 
                    pls.Add(iypagetop);  } 
                placeLs.Add(new TextPlace(ix, iytot));
                ix += wofi[wofi.Count - 1]; 
            } else { 
                if (ix+wofi[wofi.Count-1] > NA) {
                    ix = 0; iytot++; 
                    if (iytot-iypagetop >= NT) {
                        iypagetop += NT; 
                        pls.Add(iypagetop);  }  
                } 
                placeLs.Add(new TextPlace(ix, iytot));
                ix += wofi[wofi.Count - 1]; }  
        } 
        placeLs.Add(new TextPlace(ix, iytot));
        //      
        if (_iLpre >= 0) {
            _iL = _iR = _iLpre;  
            richtowardcursor();
            _iLpre = -1; } 
        // =============== see === concerning Ctrl-Z and Ctrl-Shift-Z !!! =================
        if (ctrlzypressed) { ctrlzypressed = false; return; } 
        if ((_textshence[ptrtextsnowz] != _text) || 
                    (!equalf(_modifshence[ptrtextsnowz],modifs))) { 
            for (int i=_textshence.Count-1; i>ptrtextsnowz; i--) { 
                _textshence.RemoveAt(i); 
                _modifshence.RemoveAt(i); 
                _cursorhence.RemoveAt(i); } 
            _textshence.Add(_text); 
            _modifshence.Add(copylist(modifs)); 
            _cursorhence.Add(getcursori()); 
            ptrtextsnowz++; } 
        // ================================================================================ 
    } // ========================================================================= 
    public int getcursori() {
        if (_iL == _iR) { return _iL; 
        } else { return -1; } 
    } // ==========================================================================  
    public void setcursori(int i) {
        _iL = _iR = i;
        richtowardcursor();  
    } // ==========================================================================  
    int _iLpre = -1; 
    public void setcursoripre(int i) {
        _iLpre = i; 
    } // ==========================================================================  
    public void deccursori() {
        _iL--; 
        if (_iL < 0) { _iL = 0; } 
        _iR = _iL;  
        richtowardcursor(); 
    } // ==========================================================================  
    public void inccursori() {
        _iL++; 
        if (_iL > text.Length) { _iL = text.Length; } 
        _iR = _iL;  
        richtowardcursor(); 
    } // ==========================================================================  
    public void dec10cursori() {
        TextPlace tp=placeLs[_iL];
        int iy = tp.Ttotal, inew=_iL, i=_iL, yregi=0; 
        for ( ; i>0; i--) { 
            TextPlace tphere=placeLs[i]; 
            if (tphere.Ttotal != tp.Ttotal) { 
                yregi = tphere.Ttotal; break; } } 
        for ( ; i>0; i--) { 
            TextPlace tphere=placeLs[i]; 
            if (tphere.A <= ixrealz) {  
                break; }    
        }  
        _iR = _iL = i; 
        par.textpanel.richtowardcursornonreal(); 
    } // ==========================================================================  
    public void inc10cursori() { 
        TextPlace tp=placeLs[_iL]; 
        int iy = tp.Ttotal, inew=_iL, i=_iL+1, yregi=0; 
        for ( ; i<=text.Length; i++) { 
            TextPlace tphere=placeLs[i]; 
            if (tphere.Ttotal != tp.Ttotal) { 
                yregi = tphere.Ttotal; break; } } 
        for ( ; i<=text.Length; i++) { 
            TextPlace tphere=placeLs[i]; 
            if (tphere.A > ixrealz || tphere.Ttotal != yregi) {  
                break; } }  
        _iR = _iL = i-1;  
        par.textpanel.richtowardcursornonreal(); 
    } // ==========================================================================  
    void adec(int icursori) { 
        if (icursori < 0) {
            setcursori(getiL()); 
        } else {
			deccursori(); }
    } // ========================================================================== 
    void ainc(int icursori) { 
        if (icursori < 0) {
            setcursori(getiR()); 
        } else {
		    inccursori(); }
    } // ========================================================================== 
    public void setidn(int i) {
        _iL = _iR = _idn = i; 
    } // ==========================================================================  
    public void setiup(int iup) {
        if (_idn <= iup) {
            _iL = _idn; _iR = iup; 
        } else {
            _iL = iup; _iR = _idn; 
        } 
        richtowardcursor(); 
    } // ==========================================================================  
    public int getiL() {
        return _iL; 
    } // ==========================================================================  
    public int getiR() {
        return _iR; 
    } // ==========================================================================  
    void richtowardcursor() { 
        if (_iL == -1) { return; } 
        if (_iL == _iR) {
            par.textpanel.richtowardcursornonreal();  
            ixrealz = placeLs[_iL].A; 
        } } // ==========================================================================  
    public void tofore() {
        if (ptrtextsnowz < _textshence.Count-1) {
            ptrtextsnowz++;
            _text = _textshence[ptrtextsnowz]; 
            modifs = copylist(_modifshence[ptrtextsnowz]); 
            setcursoripre(_cursorhence[ptrtextsnowz]);  
        } 
    } // ======================================================== 
    public void tobefore() { 
        if (ptrtextsnowz > 0) {
            ptrtextsnowz--; 
            _text = _textshence[ptrtextsnowz]; 
            modifs = copylist(_modifshence[ptrtextsnowz]); 
            setcursoripre(_cursorhence[ptrtextsnowz]);  
        }
    } // ======================================================== 
    public List<int> copylist(List<int> ltf) {
        List<int> lnew = new List<int>(); 
        for (int i=0; i<ltf.Count; i++) {
            lnew.Add(ltf[i]); }
        return lnew; 
    } // ======================================================== 
    List<int> listcopy(int iL, int iRlim, List<int> intstf) {
        List<int> intsnew = new List<int>(); 
        for (int i=_iL; i<iRlim; i++) { intsnew.Add(intstf[i]); }
        return intsnew; 
    } // ==========================================================================  
    bool equalf(List<int> a, List<int>b) {
        if (a.Count != b.Count) { return false; } 
        for (int i=0; i<a.Count; i++) {
            if (a[i] != b[i]) { return false; } 
        }
        return true; 
    } // ========================================================================= 
    public int getifromiAiTip(int iA, int iT, int ip) {
        int ilim = placeLs.Count; 
        for (int i=0; i<ilim; i++) {  
            if (placeLs[i].Ttotal > iT) {  
                return i-1; // if right space after cr was pointed   
            } else if (placeLs[i].Ttotal == iT) {  
                if (placeLs[i].A >= iA) { 
                    return i; }  // was <= 
            }  
        } 
        return ilim-1; 
    } // ===================================================================   
    public struct TextPlace {
        public int A, Ttotal; 
        public TextPlace(int atf, int ttotaltf) {
            A= atf;   Ttotal =ttotaltf; 
        } // ====================================================================== 
    } // ##########################################################################    
} // ############################################################################## 
public class InCertif {
    public static int numsbycode(ref bool modelinetoptf, char chr) {
        bool modelinetop = modelinetoptf;
        modelinetoptf = false; 
        int ichr = (int)chr; 
        if (ichr < 9312) { // 9312:"①"
            if (ichr < 33) {
                if(ichr == ' ') { // 32 
                    modelinetoptf = modelinetop; 
                    return 1; }
                if(ichr == '\n' || ichr == '\f') { // 10, 12  
                    modelinetoptf = true; } 
                return 0; 
            } else if (ichr < 8528 || ichr >= 8543) { 
                // if (ichr >= 8544 && ichr < 8572 && modelinetop) { return 1; }  
                return 1; 
            } else if (ichr == 8530) { return 4; 
            } else { return 3; } // 分数
        } else if (ichr < 10102) { // from 9312 
            if (ichr < 9372) { 
                int iexcess = ichr - 9312; 
                if (modelinetop) { return 1; 
                } else if (iexcess < 60 && (iexcess % 20) < 9) { return 2; 
                } else { return 3; } 
            } else { // >= 9372        9372 to 9472lim  num
                if (ichr < 9472) { 
                    if (modelinetop) { return 1; 
                    } else if (ichr < 9451) { 
                        return 2; 
                    } else if (ichr < 9461) { 
                        return 3; 
                    } else if (ichr < 9470) { 
                        return 2; 
                    } else if (ichr < 9471) {
                        return 3; 
                    } else {
                        return 2; } 
                } else {
                    return 1; 
                } 
            } 
        } else if (ichr < 10132) { // from 10102  
            int iexcess = ichr - 10102;  
            if (modelinetop) { return 1; 
            } else if ((iexcess % 10) < 9) { return 2; 
            } else { return 3; }  
        } else if (ichr < 13312) { // from 10132 
            if (ichr < 12800) { //  '」'12301   '』'12303    
                if (ichr == '　') {                        // 12288
                    modelinetoptf = modelinetop; } ; 
                return 1;  
            } else if (ichr < 12871) { // 12871
                if (modelinetop) { return 1; } 
                return 2;  
            } else if (ichr < 12896) { // 12881
                if (modelinetop) { return 1; } 
                return 3;  
            } else if (ichr < 12977) { // 12896 
                if (modelinetop && ichr >= 12928 && ichr < 12945) { return 1; } 
                return 2;  
            } else if (ichr < 12992) { // 12977
                if (modelinetop) { return 1; } 
                return 3;  
            } else if (ichr < 13056) { // 12992 
                if (modelinetop && ichr < 13004) { return 1; } 
                if (ichr == 13005 || ichr == 13007) { return 3; } 
                if (modelinetop && ichr >= 13008 && ichr < 13055) { return 1; } 
                return 2;  
            } else { // 13056
                return specialcase(chr);  
            }
        } else { // from 13312 
            return 1; 
        } 
    } // =================================================================  
    static string strs2 = "㌥㌦㌧㌨㌰㌱㌐㌔㌷㌿㍉㍋㍒㍕㍘㍙㍚㍛㍜㍝㍞㍟㍠㍡㍲㍳㍵㍶㍷㍺㍻㍼㍽㍾"+
        "㎀㎁㎂㎃㎄㎅㎆㎇㎊㎋㎌㎍㎎㎏㎐㎕㎖㎗㎘㎙㎚㎛㎜㎝㎞㎡㎥㎩㎰㎱㎲㎳㎴㎵㎶㎷㎸㎹㎺㎻㎼㎽㎾㎿㏀㏁㏃"+
        "㏄㏅㏈㏉㏊㏋㏌㏎㏏㏐㏑㏓㏔㏗㏚㏛㏜㏝㏠㏡㏢㏣㏤㏥㏦㏧㏨";
    static string strs3 = "㌃㌅㌆㌉㌊㌋㌎㌏㌑㌘㌜㌝㌞㌢㌣㌤㌩㌪㌬㌯㌵㌸㌹㌺㌻㌼㌾㍀㍁㍂㍄㍅㍆㍎㍏㍐㍓㍗"+
        "㍢㍣㍤㍥㍦㍧㍨㍩㍪㍫㍬㍭㍮㍯㍰㍱㍴㍸㍹㎈㎑㎒㎓㎔㎟㎠㎢㎣㎤㎦㎧㎪㎫㎬㎭㏇㏒㏕㏖㏙㏞㏟"+
        "㏩㏪㏫㏬㏭㏮㏯㏰㏱㏲㏳㏴㏵㏶㏷㏸㏹㏺㏻㏼㏽㏾㏿";
    static string strs4 = "㌀㌁㌂㌄㌇㌈㌌㌍㍃㌒㌓㌛㌟㌡㌭㌳㌶㌽㍈㍊㍌㍍㍑㍔㍿㎉㎨㏂㏆㏍㏘";
    static string strs5 = "㌕㌗㌠㌚㌫㌮㌲㌙㌴㍇㍖㎮"; 
    static string strs6 = "㌖㎯"; 
    static int specialcase(char chr) { 
        if (strs3.IndexOf(chr) >= 0) { return 3; 
        } else if (strs4.IndexOf(chr) >= 0) { return 4; 
        } else if (strs5.IndexOf(chr) >= 0) { return 5; 
        } else if (strs6.IndexOf(chr) >= 0) { return 6; 
        } else { return 2; } 
    } // ===================================================================================================== 
} // ##################################################################### 
//
/* 
    Tuple<int, int>[] charrangesize ={
        new Tuple<int,int>(0,0), 
        new Tuple<int,int>(33,1), 
        new Tuple<int,int>(8528,3), 
        new Tuple<int,int>(8530,4), // ⅒
        new Tuple<int,int>(8531,3), 
        new Tuple<int,int>(8543,1), 

        new Tuple<int,int>(9312,2), 
        new Tuple<int,int>(9321,3), 
        new Tuple<int,int>(9332,2), 
        new Tuple<int,int>(9341,3), 
        new Tuple<int,int>(9352,2), 
        new Tuple<int,int>(9361,3),

        new Tuple<int,int>(9372,2),
        new Tuple<int,int>(9451,3),
        new Tuple<int,int>(9461,2),
        new Tuple<int,int>(9470,3),
        new Tuple<int,int>(9471,2),
        new Tuple<int,int>(9472,1),

        new Tuple<int,int>(10102,2),
        new Tuple<int,int>(10111,3),
        new Tuple<int,int>(10112,2),
        new Tuple<int,int>(10121,3),
        new Tuple<int,int>(10122,2),
        new Tuple<int,int>(10131,3),

        new Tuple<int,int>(10132,1),
        new Tuple<int,int>(12881,3),
        new Tuple<int,int>(12896,2),
        new Tuple<int,int>(12977,3),
        new Tuple<int,int>(12992,2),  // 13005 3   13007 3    
        new Tuple<int,int>(13056,2),  // 13056 to 13312 special 

        new Tuple<int,int>(13312,1)
    };  
  */
// ---------------------- bottom of file TextBank.cs ----------------------
